diff -NaubB ./make-3.81/available_rules2.c ./make-3.81g/available_rules2.c
--- ./make-3.81/available_rules2.c	1969-12-31 21:00:00.000000000 -0300
+++ ./make-3.81g/available_rules2.c	2007-12-14 19:38:27.354927000 -0300
@@ -0,0 +1,264 @@
+#include <stdio.h>
+#include "plugin.h"
+
+const int LOG_LEVEL = 1;
+
+FILE* f;
+unsigned int level = 0;
+unsigned int rule_has_commands;
+
+/* plugin implementation */
+
+static void EnterDirectory (unsigned int makelevel, const char *directory);
+static void ExitDirectory  (void);
+static void ClosePlugin    (void);
+static void VarDefine      (const char* varname, const char* value, int origin);
+static void VarLookup      (const char* varname, const char* value, int origin);
+static void VarAppend      (const char* varname, const char* oldvalue, const char* appending, int origin);
+static void FuncCall       (const char* function);
+static void EnterMakefile  (const char* name, int flags);
+static void EnterRule      (int has_commands);
+static void RuleHeader     (const char* header);
+static void ExitRule       (void);
+static void ExitMakefile   (void);
+static void GoalSeek       (const char* goal);
+static void ProcessRuleIn  (const char* rule);
+static void ProcessRuleOut (void);
+static void CmdBefore      (const char* argv[], unsigned int argc, const char* env[], unsigned int envc);
+static void CmdAfter       (int sig, int ret);
+
+static void IfDefEval      (const char* target, const char* exp, int negated, int result);
+static void IfEqEval       (const char* op1, const char* op2, const char* exp1, const char* exp2, int negated, int result);
+
+
+
+static void TAB(void)
+{
+    int i;
+    for (i=0; i<level; i++)
+	fprintf(f, "\t");
+}
+
+/* Plugins shall implement the following function:
+*/
+void
+initialize_plugin (const char *argument, struct Plugin_data *data)
+{
+  data->enter_directory_callback = EnterDirectory;
+  data->exit_directory_callback = ExitDirectory;
+  data->close_plugin_callback = ClosePlugin;
+  /*
+  data->var_define_callback = VarDefine;
+  data->var_lookup_callback = VarLookup;
+  data->var_append_callback = VarAppend;
+  */
+  data->begin_makefile_callback = EnterMakefile;
+  data->begin_parse_rule = EnterRule;
+  data->parse_rule_header = RuleHeader;
+  data->end_parse_rule = ExitRule;
+  data->end_makefile_callback = ExitMakefile;
+
+/*
+  data->function_call_callback = FuncCall;
+    */
+  
+  /*data->goal_seek_callback = GoalSeek;*/
+  /*
+  data->rule_enter_callback = ProcessRuleIn;
+  data->rule_exit_callback = ProcessRuleOut;
+  
+  data->before_command_callback = CmdBefore;
+  data->after_command_callback = CmdAfter;
+
+  data->ifdef_eval_callback = IfDefEval;
+  data->ifeq_eval_callback = IfEqEval;
+    */
+  f = fopen("plugin.log", "wt");
+}
+
+
+static void
+EnterDirectory (unsigned int makelevel, const char *directory)
+{
+    if (level == LOG_LEVEL)
+    {
+  TAB();
+  fprintf (f, "Plugin: Entering dir %s, level %d\n", directory, makelevel);
+  /*level++;*/
+  }
+}
+
+static void
+ExitDirectory (void)
+{
+    if (level == LOG_LEVEL)
+    {
+  /*level--;*/
+  TAB();
+  fprintf (f, "Plugin: Exiting dir\n");
+  }
+}
+
+static void
+ClosePlugin ()
+{
+  fprintf (f, "Plugin: Closing\n");
+  fclose(f);
+}
+
+static void
+VarDefine (const char* varname, const char* value, int origin)
+{
+  TAB();
+  fprintf (f, "Plugin: %s = '%s' at %d\n", varname, value, origin);
+}
+
+static void
+VarLookup (const char* varname, const char* value, int origin)
+{
+  TAB();
+  if (value != 0)
+      fprintf (f, "Plugin: var lookup: %s = '%s' at %d\n", varname, value, origin);
+  else
+      fprintf (f, "Plugin: var %s lookup FAILED\n", varname);
+}
+
+static void
+VarAppend (const char* varname, const char* oldvalue, const char* appending, int origin)
+{
+  TAB();
+  fprintf (f, "Plugin: %s += '%s' at %d (old='%s')\n", varname, appending, origin, oldvalue);
+}
+
+static void
+FuncCall (const char* function)
+{
+  TAB();
+  fprintf (f, "Plugin: call to %s\n", function);
+}
+
+static void
+EnterMakefile  (const char* name, int flags)
+{
+    level++;
+    if (level == LOG_LEVEL)
+    {
+	TAB();
+	fprintf(f, "Plugin: enter makefile '%s' flags=%d\n", name, flags);
+	/*level++;*/
+    }
+}
+
+static void
+EnterRule (int has_commands)
+{
+    if (level == LOG_LEVEL)
+    {
+    TAB();
+    rule_has_commands = has_commands;
+    }
+}
+
+static void
+RuleHeader (const char* header)
+{
+    if (level == LOG_LEVEL)
+    {
+	if (strchr(header, ".") == NULL
+	    fprintf(f, "%s ", header);
+    }
+}
+
+static void
+ExitRule (void)
+{
+    if (level == LOG_LEVEL)
+    {
+    if (rule_has_commands)
+	fprintf(f, ": {}\n");
+    else
+	fprintf(f, ": {CMDS}\n");
+    }
+}
+
+static void
+ExitMakefile (void)
+{
+    if (level == LOG_LEVEL)
+    {
+    TAB();
+    fprintf(f, "Plugin: exit makefile\n");
+    /*level--;*/
+    }
+    level--;
+}
+
+static void
+ProcessRuleIn (const char* rule)
+{
+    TAB();
+    fprintf(f, "Plugin: processing rule '%s'\n", rule);
+    level++;
+}
+
+static void
+ProcessRuleOut (void)
+{
+    level--;
+    TAB();
+    fprintf(f, "Plugin: processing rule out\n");
+}
+
+
+static void
+CmdBefore (const char* argv[], unsigned int argc, const char* env[], unsigned int envc)
+{
+    unsigned int i;
+    TAB();
+    fprintf(f, "Plugin: before execute '%s'\n", argv[0]);
+    TAB();
+    fprintf(f, "\tARGS: ");
+    for(i=1; i<argc; i++)
+	fprintf(f, "%s ", argv[i]);
+    fprintf(f, "\n");
+#if 0
+    TAB();
+    fprintf(f, "\tENV: ");
+    for(i=0; i<envc; i++)
+	fprintf(f, "%s ", env[i]);
+    fprintf(f, "\n");
+#endif
+}
+
+static void
+CmdAfter (int sig, int ret)
+{
+    TAB();
+    if (sig != 0 || ret != 0)
+	fprintf(f, "Plugin: command failed, returned %d, sig %d\n", ret, sig);
+    else
+	fprintf(f, "Plugin: after execute, returned %d\n", ret);
+}
+
+static void
+IfDefEval (const char* target, const char* exp, int negated, int result)
+{
+    TAB();
+    fprintf(f, "%s %s (='%s') returned %s\n", 
+	(negated ? "IFNDEF" : "IFDEF"),
+	target, 
+	exp, 
+	(result ? "TRUE" : "FALSE"));
+}
+
+static void
+IfEqEval (const char* op1, const char* op2, const char* exp1, const char* exp2, int negated, int result)
+{
+    TAB();
+    fprintf(f, "%s %s == %s ('%s' == '%s') returned %s\n", 
+	(negated ? "IFNEQ" : "IFEQ"),
+	op1, op2,
+	exp1, exp2,
+	(result ? "TRUE" : "FALSE"));
+}
+
diff -NaubB ./make-3.81/available_rules.c ./make-3.81g/available_rules.c
--- ./make-3.81/available_rules.c	1969-12-31 21:00:00.000000000 -0300
+++ ./make-3.81g/available_rules.c	2007-12-14 19:53:50.852947000 -0300
@@ -0,0 +1,283 @@
+#include <stdio.h>
+#include <string.h>
+#include "plugin.h"
+
+const int LOG_LEVEL = 1;
+
+FILE* f;
+unsigned int level = 0;
+unsigned int rule_has_commands;
+int printing_rule;
+
+/* plugin implementation */
+
+static void EnterDirectory (unsigned int makelevel, const char *directory);
+static void ExitDirectory  (void);
+static void ClosePlugin    (void);
+#if 0
+static void VarDefine      (const char* varname, const char* value, int origin);
+static void VarLookup      (const char* varname, const char* value, int origin);
+static void VarAppend      (const char* varname, const char* oldvalue, const char* appending, int origin);
+static void FuncCall       (const char* function);
+#endif
+static void EnterMakefile  (const char* name, int flags);
+static void EnterRule      (int has_commands);
+static void RuleHeader     (const char* header);
+static void ExitRule       (void);
+static void ExitMakefile   (void);
+#if 0
+static void GoalSeek       (const char* goal);
+static void ProcessRuleIn  (const char* rule);
+static void ProcessRuleOut (void);
+static void CmdBefore      (const char* argv[], unsigned int argc, const char* env[], unsigned int envc);
+static void CmdAfter       (int sig, int ret);
+static void IfDefEval      (const char* target, const char* exp, int negated, int result);
+static void IfEqEval       (const char* op1, const char* op2, const char* exp1, const char* exp2, int negated, int result);
+#endif
+
+
+
+static void TAB(void)
+{
+    int i;
+    for (i=0; i<level; i++)
+	fprintf(f, "\t");
+}
+
+/* Plugins shall implement the following function:
+*/
+void
+initialize_plugin (const char *argument, struct Plugin_data *data)
+{
+  data->enter_directory_callback = EnterDirectory;
+  data->exit_directory_callback = ExitDirectory;
+  data->close_plugin_callback = ClosePlugin;
+  /*
+  data->var_define_callback = VarDefine;
+  data->var_lookup_callback = VarLookup;
+  data->var_append_callback = VarAppend;
+  */
+  data->begin_makefile_callback = EnterMakefile;
+  data->begin_parse_rule = EnterRule;
+  data->parse_rule_header = RuleHeader;
+  data->end_parse_rule = ExitRule;
+  data->end_makefile_callback = ExitMakefile;
+
+/*
+  data->function_call_callback = FuncCall;
+    */
+  
+  /*data->goal_seek_callback = GoalSeek;*/
+  /*
+  data->rule_enter_callback = ProcessRuleIn;
+  data->rule_exit_callback = ProcessRuleOut;
+  
+  data->before_command_callback = CmdBefore;
+  data->after_command_callback = CmdAfter;
+
+  data->ifdef_eval_callback = IfDefEval;
+  data->ifeq_eval_callback = IfEqEval;
+    */
+  f = fopen("plugin.log", "wt");
+}
+
+
+static void
+EnterDirectory (unsigned int makelevel, const char *directory)
+{
+    if (level == LOG_LEVEL)
+    {
+  TAB();
+  fprintf (f, "Plugin: Entering dir %s, level %d\n", directory, makelevel);
+  /*level++;*/
+  }
+}
+
+static void
+ExitDirectory (void)
+{
+    if (level == LOG_LEVEL)
+    {
+  /*level--;*/
+  TAB();
+  fprintf (f, "Plugin: Exiting dir\n");
+  }
+}
+
+static void
+ClosePlugin ()
+{
+  fprintf (f, "Plugin: Closing\n");
+  fclose(f);
+}
+
+#if 0
+static void
+VarDefine (const char* varname, const char* value, int origin)
+{
+  TAB();
+  fprintf (f, "Plugin: %s = '%s' at %d\n", varname, value, origin);
+}
+
+static void
+VarLookup (const char* varname, const char* value, int origin)
+{
+  TAB();
+  if (value != 0)
+      fprintf (f, "Plugin: var lookup: %s = '%s' at %d\n", varname, value, origin);
+  else
+      fprintf (f, "Plugin: var %s lookup FAILED\n", varname);
+}
+
+static void
+VarAppend (const char* varname, const char* oldvalue, const char* appending, int origin)
+{
+  TAB();
+  fprintf (f, "Plugin: %s += '%s' at %d (old='%s')\n", varname, appending, origin, oldvalue);
+}
+
+static void
+FuncCall (const char* function)
+{
+  TAB();
+  fprintf (f, "Plugin: call to %s\n", function);
+}
+#endif
+
+static void
+EnterMakefile  (const char* name, int flags)
+{
+    level++;
+    if (level == LOG_LEVEL)
+    {
+	TAB();
+	fprintf(f, "Plugin: enter makefile '%s' flags=%d\n", name, flags);
+	/*level++;*/
+    }
+}
+
+static void
+EnterRule (int has_commands)
+{
+    if (level == LOG_LEVEL)
+    {
+	rule_has_commands = has_commands;
+	printing_rule = 0;
+    }
+}
+
+static void
+RuleHeader (const char* header)
+{
+    if (level == LOG_LEVEL)
+    {
+	if (strchr(header, '.') == NULL)
+	{
+	    if (!printing_rule)
+	    {
+		TAB();
+		printing_rule = 1;
+	    }
+	    fprintf(f, "%s ", header);
+	}
+    }
+}
+
+static void
+ExitRule (void)
+{
+    if (level == LOG_LEVEL)
+    {
+	if (printing_rule)
+	{
+	    if (rule_has_commands)
+		fprintf(f, ": {}\n");
+	    else
+		fprintf(f, ": {CMDS}\n");
+	}
+    }
+}
+
+static void
+ExitMakefile (void)
+{
+    if (level == LOG_LEVEL)
+    {
+	TAB();
+	fprintf(f, "Plugin: exit makefile\n");
+	/*level--;*/
+    }
+    level--;
+}
+
+#if 0
+static void
+ProcessRuleIn (const char* rule)
+{
+    TAB();
+    fprintf(f, "Plugin: processing rule '%s'\n", rule);
+    level++;
+}
+
+static void
+ProcessRuleOut (void)
+{
+    level--;
+    TAB();
+    fprintf(f, "Plugin: processing rule out\n");
+}
+
+
+static void
+CmdBefore (const char* argv[], unsigned int argc, const char* env[], unsigned int envc)
+{
+    unsigned int i;
+    TAB();
+    fprintf(f, "Plugin: before execute '%s'\n", argv[0]);
+    TAB();
+    fprintf(f, "\tARGS: ");
+    for(i=1; i<argc; i++)
+	fprintf(f, "%s ", argv[i]);
+    fprintf(f, "\n");
+#if 0
+    TAB();
+    fprintf(f, "\tENV: ");
+    for(i=0; i<envc; i++)
+	fprintf(f, "%s ", env[i]);
+    fprintf(f, "\n");
+#endif
+}
+
+static void
+CmdAfter (int sig, int ret)
+{
+    TAB();
+    if (sig != 0 || ret != 0)
+	fprintf(f, "Plugin: command failed, returned %d, sig %d\n", ret, sig);
+    else
+	fprintf(f, "Plugin: after execute, returned %d\n", ret);
+}
+
+static void
+IfDefEval (const char* target, const char* exp, int negated, int result)
+{
+    TAB();
+    fprintf(f, "%s %s (='%s') returned %s\n", 
+	(negated ? "IFNDEF" : "IFDEF"),
+	target, 
+	exp, 
+	(result ? "TRUE" : "FALSE"));
+}
+
+static void
+IfEqEval (const char* op1, const char* op2, const char* exp1, const char* exp2, int negated, int result)
+{
+    TAB();
+    fprintf(f, "%s %s == %s ('%s' == '%s') returned %s\n", 
+	(negated ? "IFNEQ" : "IFEQ"),
+	op1, op2,
+	exp1, exp2,
+	(result ? "TRUE" : "FALSE"));
+}
+#endif
+
Common subdirectories: ./make-3.81/config and ./make-3.81g/config
diff -NaubB ./make-3.81/config.h.in ./make-3.81g/config.h.in
--- ./make-3.81/config.h.in	2006-04-01 03:40:00.000000000 -0300
+++ ./make-3.81g/config.h.in	2007-12-12 20:18:42.000000000 -0300
@@ -338,6 +338,10 @@
 /* Define to the version of this package. */
 #undef PACKAGE_VERSION
 
+/* Sets the default parser behaviour as POSIX regarding backspace and new line
+   */
+#undef POSIX_BSNL
+
 /* Define to 1 if the C compiler supports function prototypes. */
 #undef PROTOTYPES
 
diff -NaubB ./make-3.81/configure.in ./make-3.81g/configure.in
--- ./make-3.81/configure.in	2006-04-01 03:36:40.000000000 -0300
+++ ./make-3.81g/configure.in	2007-12-12 20:05:36.000000000 -0300
@@ -16,7 +16,7 @@
 # GNU Make; see the file COPYING.  If not, write to the Free Software
 # Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
 
-AC_INIT([GNU make],[3.81],[bug-make@gnu.org])
+AC_INIT([GNU make],[3.81g],[bug-make@gnu.org])
 
 AC_PREREQ(2.59)
 AC_REVISION([[$Id: configure.in,v 1.142 2006/04/01 06:36:40 psmith Exp $]])
@@ -276,6 +276,14 @@
   [make_cv_job_server="$enableval" user_job_server="$enableval"],
   [make_cv_job_server="yes"])
 
+AC_ARG_ENABLE(default-posix, 
+	AC_HELP_STRING([--disable-default-posix],
+                 [Sets the default parser behaviour as NON POSIX regarding backspace and new line]),
+    ,
+    AC_DEFINE(POSIX_BSNL,
+   				 0, [Sets the default parser behaviour as POSIX regarding backspace and new line])
+   ) 
+  
 has_wait_nohang=yes
 case "$ac_cv_func_waitpid/$ac_cv_func_wait3" in
   no/no) has_wait_nohang=no ;;
Common subdirectories: ./make-3.81/doc and ./make-3.81g/doc
diff -NaubB ./make-3.81/function.c ./make-3.81g/function.c
--- ./make-3.81/function.c	2006-04-01 03:36:40.000000000 -0300
+++ ./make-3.81g/function.c	2007-12-06 13:35:31.000000000 -0300
@@ -23,6 +23,7 @@
 #include "job.h"
 #include "commands.h"
 #include "debug.h"
+#include "plugin_support.h"
 
 #ifdef _AMIGA
 #include "amiga.h"
@@ -268,6 +269,14 @@
       function_table_entry_key.name = s;
       function_table_entry_key.len = e - s;
 
+      {
+        char* const function_name = (char*)malloc(function_table_entry_key.len+1);
+	memcpy(function_name, function_table_entry_key.name, function_table_entry_key.len);
+	function_name[function_table_entry_key.len] = 0;
+        notify_function_call(function_name);
+	free(function_name);
+      }
+
       return hash_find_item (&function_table, &function_table_entry_key);
     }
   return 0;
Common subdirectories: ./make-3.81/glob and ./make-3.81g/glob
diff -NaubB ./make-3.81/job.c ./make-3.81g/job.c
--- ./make-3.81/job.c	2006-03-20 00:03:04.000000000 -0300
+++ ./make-3.81g/job.c	2007-12-11 13:05:33.000000000 -0300
@@ -26,6 +26,7 @@
 #include "commands.h"
 #include "variable.h"
 #include "debug.h"
+#include "plugin_support.h"
 
 #include <string.h>
 
@@ -230,6 +231,8 @@
 
 unsigned int jobserver_tokens = 0;
 
+extern int posix_flag;
+
 #ifdef WINDOWS32
 /*
  * The macro which references this function is defined in make.h.
@@ -681,6 +684,8 @@
 	  break;
 	}
 
+      notify_after_command(exit_sig, exit_code);
+
       child_failed = exit_sig != 0 || exit_code != 0;
 
       /* Search for a child matching the deceased one.  */
@@ -2074,9 +2079,13 @@
 # else
 
   /* Run the program.  */
+  notify_before_command(argv, envp);
+  
   environ = envp;
   execvp (argv[0], argv);
 
+  notify_command_failure(errno);
+
 # endif /* !__EMX__ */
 
   switch (errno)
@@ -2730,7 +2739,7 @@
 #else
 # define PRESERVE_BSNL  1
 #endif
-	    if (PRESERVE_BSNL)
+	    if (PRESERVE_BSNL && posix_flag)
 	      {
 		*(ap++) = '\\';
 		*(ap++) = '\\';
diff -NaubB ./make-3.81/main.c ./make-3.81g/main.c
--- ./make-3.81/main.c	2006-03-19 23:36:37.000000000 -0300
+++ ./make-3.81g/main.c	2007-12-12 16:21:10.000000000 -0300
@@ -25,6 +25,7 @@
 #include "rule.h"
 #include "debug.h"
 #include "getopt.h"
+#include "plugin_support.h"
 
 #include <assert.h>
 #ifdef _AMIGA
@@ -163,6 +164,20 @@
 int suspend_flag = 0;
 #endif
 
+#if PLUGIN_SUPPORT
+/* Plugin support flags */
+static struct stringlist *plugins_names;
+static int plugin_mq = -1;
+unsigned int global_mq = 0;
+static int plugin_alive = 0;
+#endif
+
+#ifdef POSIX_BSNL
+int posix_flag = 1;
+#else
+int posix_flag = 0;
+#endif
+
 /* Environment variables override makefile definitions.  */
 
 int env_overrides = 0;
@@ -325,11 +340,22 @@
     N_("\
   -n, --just-print, --dry-run, --recon\n\
                               Don't actually run any commands; just print them.\n"),
+#ifdef POSIX_BSNL
+    N_("\
+  -N, --no-posix              Behave as pre-3.81 version regarding backspace newlines.\n"),
+#else
+    N_("\
+  -N, --posix                 Be POSIX, as 3.81 version, regarding backspace newlines.\n"),
+#endif
     N_("\
   -o FILE, --old-file=FILE, --assume-old=FILE\n\
                               Consider FILE to be very old and don't remake it.\n"),
     N_("\
   -p, --print-data-base       Print make's internal database.\n"),
+#if PLUGIN_SUPPORT
+    N_("\
+  -P, --plugin PLUGIN         Load PLUGIN and report events to it.\n"),
+#endif
     N_("\
   -q, --question              Run no commands; exit status says if up to date.\n"),
     N_("\
@@ -396,9 +422,17 @@
       "check-symlink-times" },
     { 'm', ignore, 0, 0, 0, 0, 0, 0, 0 },
     { 'n', flag, (char *) &just_print_flag, 1, 1, 1, 0, 0, "just-print" },
+#ifdef POSIX_BSNL
+    { 'N', flag_off, (char *) &posix_flag, 1, 1, 1, 0, 0, "no-posix" },
+#else
+    { 'N', flag, (char *) &posix_flag, 1, 1, 1, 0, 0, "posix" },
+#endif
     { 'o', string, (char *) &old_files, 0, 0, 0, 0, 0, "old-file" },
     { 'p', flag, (char *) &print_data_base_flag, 1, 1, 0, 0, 0,
       "print-data-base" },
+#if PLUGIN_SUPPORT
+    { 'P', string, (char *) &plugins_names, 0, 0, 0, 0, 0, "plugin" },
+#endif
     { 'q', flag, (char *) &question_flag, 1, 1, 1, 0, 0, "question" },
     { 'r', flag, (char *) &no_builtin_rules_flag, 1, 1, 0, 0, 0,
       "no-builtin-rules" },
@@ -408,6 +442,10 @@
     { 'S', flag_off, (char *) &keep_going_flag, 1, 1, 0, 0,
       (char *) &default_keep_going_flag, "no-keep-going" },
     { 't', flag, (char *) &touch_flag, 1, 1, 1, 0, 0, "touch" },
+#if PLUGIN_SUPPORT
+    { 'u', flag, (char *) &plugin_alive, 1, 1, 0, 0, 0, "plugin_alive" },
+    { 'U', positive_int, (char *) &global_mq, 1, 1, 0, 0, 0, "MESSAGE_QUEUE" },
+#endif
     { 'v', flag, (char *) &print_version_flag, 1, 1, 0, 0, 0, "version" },
     { 'w', flag, (char *) &print_directory_flag, 1, 1, 0, 0, 0,
       "print-directory" },
@@ -1253,6 +1292,33 @@
       if (print_version_flag)
         die (0);
     }
+#if PLUGIN_SUPPORT
+  if (plugins_names != NULL)
+  {
+    if (plugins_names->max != 0)
+    {
+      if ( plugins_names->list[0] != NULL )
+      {
+         plugin_mq = launch_plugin(plugins_names->list[0], "argument");
+	 global_mq = (unsigned int)plugin_mq;
+	 if (plugin_mq != -1)
+	 {
+	    plugin_alive = 1;
+	 }
+      }
+    }
+  }
+  else if (plugin_alive != 0)
+  {
+    plugin_mq = (int)global_mq;
+    connect_to_plugin(plugin_mq);
+  }
+  else
+  {
+    /* fake, just for avoiding error message */
+    global_mq = 1;
+  }
+#endif
 
 #ifndef VMS
   /* Set the "MAKE_COMMAND" variable to the name we were invoked with.
@@ -2101,6 +2166,7 @@
 	    exit (WIFEXITED(status) ? WEXITSTATUS(status) : EXIT_FAILURE);
 	  }
 #else
+	  disconnect_from_plugin(1);
 	  exec_command (nargv, environ);
 #endif
 	  /* NOTREACHED */
@@ -3069,6 +3135,8 @@
 	chdir (directory_before_chdir);
 
       log_working_directory (0);
+    
+      disconnect_from_plugin(0);
     }
 
   exit (status);
@@ -3093,6 +3161,11 @@
   if (print_data_base_flag)
     fputs ("# ", stdout);
 
+  if (entering)
+    notify_entry_dir(makelevel, starting_directory);
+  else
+    notify_exit_dir();
+
   /* Use entire sentences to give the translators a fighting chance.  */
 
   if (makelevel == 0)
diff -NaubB ./make-3.81/Makefile.am ./make-3.81g/Makefile.am
--- ./make-3.81/Makefile.am	2006-04-01 03:36:40.000000000 -0300
+++ ./make-3.81g/Makefile.am	2007-12-12 19:51:21.000000000 -0300
@@ -26,6 +26,8 @@
   MAYBE_W32 =	w32
   W32INC =	-I $(top_srcdir)/w32/include
   W32LIB =	-Lw32 -lw32
+else
+  DLLIB = -ldl
 endif
 
 SUBDIRS =	glob config po doc $(MAYBE_W32)
@@ -41,18 +43,20 @@
 
 make_SOURCES =	ar.c arscan.c commands.c default.c dir.c expand.c file.c \
 		function.c getopt.c getopt1.c implicit.c job.c main.c \
-		misc.c read.c remake.c $(remote) rule.c signame.c \
+		misc.c plugin_support.c read.c remake.c $(remote) rule.c signame.c \
 		strcache.c variable.c version.c vpath.c hash.c
 
 EXTRA_make_SOURCES = vmsjobs.c remote-stub.c remote-cstms.c
 
 noinst_HEADERS = commands.h dep.h filedef.h job.h make.h rule.h variable.h \
-		debug.h getopt.h gettext.h hash.h
+		debug.h getopt.h gettext.h hash.h plugin_support.h
 
 make_LDADD =	@LIBOBJS@ @ALLOCA@ $(GLOBLIB) @GETLOADAVG_LIBS@ @LIBINTL@
 # Only process if target is MS-Windows
 if WINDOWSENV
     make_LDADD += $(W32LIB)
+else
+    make_LDADD += $(DLLIB)
 endif
 
 man_MANS =	make.1
@@ -69,14 +73,14 @@
 # Extra stuff to include in the distribution.
 
 EXTRA_DIST =	README build.sh.in $(man_MANS) \
-		README.customs README.OS2 \
+		README.customs README.OS2 PLUGINS_SUPPORT.txt \
 		SCOPTIONS SMakefile \
 		README.Amiga Makefile.ami config.ami make.lnk amiga.c amiga.h \
 		README.DOS Makefile.DOS configure.bat dosbuild.bat configh.dos\
 		README.W32 NMakefile config.h.W32 build_w32.bat subproc.bat \
 		make_msvc_net2003.sln make_msvc_net2003.vcproj \
 		readme.vms makefile.vms makefile.com config.h-vms \
-		vmsdir.h vmsfunctions.c vmsify.c
+		vmsdir.h vmsfunctions.c vmsify.c plugin.h
 
 # This is built during configure, but behind configure's back
 
diff -NaubB ./make-3.81/NEWS ./make-3.81g/NEWS
--- ./make-3.81/NEWS	2006-04-01 03:36:40.000000000 -0300
+++ ./make-3.81g/NEWS	2007-12-12 20:20:01.000000000 -0300
@@ -9,6 +9,12 @@
 See the README file and the GNU make manual for instructions for
 reporting bugs.
 
+Version 3.81g
+
+* Added plugins support
+
+
+
 Version 3.81
 
 * GNU make is ported to OS/2.
diff -NaubB ./make-3.81/plugin.h ./make-3.81g/plugin.h
--- ./make-3.81/plugin.h	1969-12-31 21:00:00.000000000 -0300
+++ ./make-3.81g/plugin.h	2007-12-06 16:02:27.000000000 -0300
@@ -0,0 +1,35 @@
+/* Header for plugin integration */
+
+
+struct Plugin_data
+{
+  void (*enter_directory_callback) (unsigned int makelevel, const char *directory);
+  void (*exit_directory_callback)  (void);
+  void (*close_plugin_callback)    (void);
+  
+  void (*begin_makefile_callback)  (const char* name, int flags);
+  void (*parse_implicit_rule)      (const char* rule, int has_commands);    /* not yet implemented (don't remember actually :D ) */
+  void (*begin_parse_rule)         (int has_commands);
+  void (*parse_rule_header)        (const char* header);
+  void (*end_parse_rule)           (void);
+  void (*end_makefile_callback)    (void);
+  void (*ifdef_eval_callback)      (const char* target, const char* exp, int negated, int result); /* negated: ifndef */
+  void (*ifeq_eval_callback)       (const char* op1, const char* op2, const char* exp1, const char* exp2, int negated, int result); /* negated: ifneq */
+  
+  void (*var_define_callback)      (const char* varname, const char* value, int origin);
+  void (*var_lookup_callback)      (const char* varname, const char* value, int origin);  /* value == NULL means not found */
+  void (*var_append_callback)      (const char* varname, const char* oldvalue, const char* appending, int origin); /* not yet implemented */
+
+/*  void (*goal_seek_callback)       (const char* goal);*/
+  void (*rule_enter_callback)      (const char* rule);
+  void (*rule_exit_callback)       (void);
+  
+  void (*before_command_callback)  (const char* argv[], unsigned int argc, const char* env[], unsigned int envc); /* argc >= 1 */
+  void (*after_command_callback)   (int sig, int ret);
+  
+  void (*function_call_callback)   (const char* function_name);
+};
+
+/* Plugins shall implement the following function:
+void initialize_plugin (const char *argument, struct Plugin_data *data);
+*/
